# frozen_string_literal: true

module Chotto
  class Database
    attr_reader :db

    def initialize(path:, db_class:)
      @db = db_class.new(path, mode: Notmuch::MODE_READ_WRITE)
    end

    def search_messages(query)
      db.query(query).search_messages
    end

    def close
      db.close
    end
  end
end
