# frozen_string_literal: true

module Chotto
  class Message
    attr_reader :message, :messages, :db

    # attr_accessor :tags

    def initialize(msg:, db:)
      @message = msg
      @db = db
      # @tags = MessageTags.new(message: message)
    end

    def method_missing(method_name, *_args)
      handle_get_header(Chotto::Helpers.header_name_from_dsl(method_name))
    end

    def tags
      @tags ||= message.tags
    end

    attr_writer :tags

    def save!
      message.remove_all_tags
      tags.each do |tag|
        message.add_tag(tag.to_s)
      end
    end

    def thread
      thread_id = message.thread_id
      MessageThread.new(thread_id: thread_id, db: db)
    end

    private

    def handle_get_header(header_name)
      message.header(header_name)
    end
  end
end
