# frozen_string_literal: true

module Chotto
  class MessageThread
    attr_reader :thread_id, :db

    def initialize(thread_id:, db:)
      @thread_id = thread_id
      @db = db
    end

    def each
      db.search_messages("thread:#{thread_id}").each do |msg|
        yield(
            Message.new(
              msg: msg,
              db: db
            ))
      end
    end
  end
end
