# frozen_string_literal: true

module Chotto
  TokenGroup = Struct.new(:conjuction, :tokens, :messages) do
    def initialize(*)
      super
    end

    def to_query
      tokens.flat_map(&:to_query).join(' ').to_s
    end

    def push_token(field, value)
      if value.is_a? String
        tokens.push(Token.new(conjuction, field, value, messages))
      elsif value.is_a? Array
        group = TokenGroup.new(OR_CONJUCTION, [], messages)
        value.each do |val|
          group.push_token(field, val)
        end
        tokens.push group

      end
    end

    def next_token_id
      @token_count += 1
    end
  end
end
